----------------------
-- general settings --
----------------------
local set = vim.opt

set.wrap 			= true
set.linebreak 		= true
set.breakindent 	= true
set.breakindentopt 	= {'shift:2', 'sbr'}
set.showbreak 		= ' >'

set.number 			= true
set.relativenumber 	= true
set.encoding 		= "utf-8"

-- search
set.hlsearch 		= true
set.ignorecase 		= true
set.smartcase 		= true

-- indentation
set.smarttab 		= true
set.expandtab 		= false
set.copyindent 		= true
set.preserveindent 	= true
set.tabstop 		= 4
set.shiftwidth 		= 4
set.softtabstop 	= 0

local group = vim.api.nvim_create_augroup("WrapMarkdown", { clear = true })
vim.api.nvim_create_autocmd("FileType", {
	pattern = "markdown,txt",
	callback = function()
		vim.opt_local.colorcolumn = "100"
		vim.opt_local.textwidth = 100
	end,
	group = WrapMarkdown,
})

vim.cmd [[
	let g:vim_markdown_folding_disabled=1
]]

-- removes the background color to have it transparent
vim.api.nvim_create_autocmd({"ColorScheme"}, {
	pattern = {"*"},
	command = "hi Normal ctermbg=none guibg=none",
})
vim.cmd("colorscheme kanagawa")

require('plugins')
--require('core.colors')
require('core.mappings')

